#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Chart;
using Syncfusion.Drawing;

namespace Syncfusion.Windows.Forms.Chart.Samples
{
  /// <summary>
  /// The ChartControl sample form.
  /// </summary>
  public class FormMain : Form
  {
    /// <summary>
    /// Required designer variable.
    /// </summary>
    private Container components = null;
  	private System.Windows.Forms.Panel panel1;
  	private System.Windows.Forms.GroupBox groupBox1;
  	private System.Windows.Forms.RadioButton radioButton1;
  	private System.Windows.Forms.RadioButton radioButton2;

    ///////////////////////////////////////////////////////////////////////////////
	  private ChartInteractiveCursor chart1;
	  private ChartInteractiveCursor chart2;
      private Point clickPoint = Point.Empty;
      private bool interactiveCursorMouseDown = false;
      private ChartInteractiveCursor interactiveCursorDown = null;
    private ChartAreaCursorCollection interactiveCursors = new ChartAreaCursorCollection();

    ///////////////////////////////////////////////////////////////////////////////////


  	private Syncfusion.Windows.Forms.ColorPickerButton colorPickerButton1;
      private Label label2;
      private Label label1;
      private Label label4;
      private Label label3;
      private Label label6;
      private Label label5;
		
    private ChartControl chartControl1;
    
    public FormMain()
    {
      //
      // Required for Windows Form Designer support
      //
      InitializeComponent();
	
    }

      public ChartAreaCursorCollection InteractiveCursors
      {
          get
          {
              return interactiveCursors;
          }
      }

	  private void InitializeControlSettings()
	  {
			this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

		  // Specify a ChartPalette:
		  Color[] color = new Color[]{Color.FromArgb(255,110,2), Color.FromArgb(41,65,125),Color.FromArgb(139,47,26)};
		  this.chartControl1.Palette = ChartColorPalette.Custom ;
		  this.chartControl1.Model.ColorModel.CustomColors = color;
		  this.chartControl1.Palette = ChartColorPalette.Custom ;

		  this.chartControl1.LegendPosition = ChartDock.Top;
		  this.chartControl1.HidePartialLabels = true;
		  this.chartControl1.PrimaryXAxis.DrawGrid=false;
		  this.chartControl1.PrimaryYAxis.DrawGrid=false;
          this.chartControl1.ChartAreaPaint += new PaintEventHandler(chartControl1_ChartAreaPaint);
          this.chartControl1.EnableXZooming = true;
          this.chartControl1.EnableXZooming = true;
	  }

      

    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    protected override void Dispose( bool disposing )
    {
      if( disposing )
      {
        if (components != null) 
        {
          components.Dispose();
        }
      }
      base.Dispose( disposing );
    }

    #region Windows Form Designer generated code
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
        System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(FormMain));
        this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
        this.panel1 = new System.Windows.Forms.Panel();
        this.groupBox1 = new System.Windows.Forms.GroupBox();
        this.colorPickerButton1 = new Syncfusion.Windows.Forms.ColorPickerButton();
        this.radioButton2 = new System.Windows.Forms.RadioButton();
        this.radioButton1 = new System.Windows.Forms.RadioButton();
        this.label1 = new System.Windows.Forms.Label();
        this.label2 = new System.Windows.Forms.Label();
        this.label3 = new System.Windows.Forms.Label();
        this.label4 = new System.Windows.Forms.Label();
        this.label5 = new System.Windows.Forms.Label();
        this.label6 = new System.Windows.Forms.Label();
        this.panel1.SuspendLayout();
        this.groupBox1.SuspendLayout();
        this.SuspendLayout();
        // 
        // chartControl1
        // 
        this.chartControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                    | System.Windows.Forms.AnchorStyles.Left)
                    | System.Windows.Forms.AnchorStyles.Right)));
        this.chartControl1.BackInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb(((int)(((byte)(203)))), ((int)(((byte)(209)))), ((int)(((byte)(226))))), System.Drawing.Color.FromArgb(((int)(((byte)(227)))), ((int)(((byte)(232)))), ((int)(((byte)(243))))));
        // 
        // 
        // 
        this.chartControl1.ChartArea.AxesSideBySide = true;
        this.chartControl1.ChartArea.BackInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb(((int)(((byte)(203)))), ((int)(((byte)(209)))), ((int)(((byte)(226))))), System.Drawing.Color.FromArgb(((int)(((byte)(227)))), ((int)(((byte)(232)))), ((int)(((byte)(243))))));
        this.chartControl1.ChartArea.ChartAreaMargins.Bottom = 10;
        this.chartControl1.ChartArea.ChartAreaMargins.Left = 10;
        this.chartControl1.ChartArea.ChartAreaMargins.Right = 20;
        this.chartControl1.ChartArea.ChartAreaMargins.Top = 10;
        this.chartControl1.ChartArea.ChartPlotAreaMargins.Bottom = 10;
        this.chartControl1.ChartArea.ChartPlotAreaMargins.Left = 10;
        this.chartControl1.ChartArea.ChartPlotAreaMargins.Right = 20;
        this.chartControl1.ChartArea.ChartPlotAreaMargins.Top = 10;
        this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb(((int)(((byte)(203)))), ((int)(((byte)(209)))), ((int)(((byte)(226))))), System.Drawing.Color.FromArgb(((int)(((byte)(227)))), ((int)(((byte)(232)))), ((int)(((byte)(243))))));
        // 
        // 
        // 
        this.chartControl1.Legend.BackColor = System.Drawing.SystemColors.Control;
        this.chartControl1.Legend.Font = new System.Drawing.Font("Verdana", 10F);
        this.chartControl1.Legend.ItemsShadowColor = System.Drawing.Color.Gray;
        this.chartControl1.Legend.Location = new System.Drawing.Point(212, 49);
        this.chartControl1.Legend.Name = "";
        this.chartControl1.Legend.Orientation = Syncfusion.Windows.Forms.Chart.ChartOrientation.Horizontal;
        this.chartControl1.Legend.RepresentationType = Syncfusion.Windows.Forms.Chart.ChartLegendRepresentationType.None;
        this.chartControl1.Legend.TabIndex = 3;
        this.chartControl1.Legend.TextColor = System.Drawing.Color.Black;
        this.chartControl1.LegendPosition = Syncfusion.Windows.Forms.Chart.ChartDock.Top;
        this.chartControl1.Location = new System.Drawing.Point(0, 0);
        this.chartControl1.Name = "chartControl1";
        this.chartControl1.Palette = Syncfusion.Windows.Forms.Chart.ChartColorPalette.Default;
        this.chartControl1.PrimaryXAxis.LabelAligment = System.Drawing.StringAlignment.Center;
        this.chartControl1.PrimaryXAxis.Orientation = Syncfusion.Windows.Forms.Chart.ChartOrientation.Horizontal;
        this.chartControl1.PrimaryXAxis.SmartDateZoomMonthLevelLabelFormat = "m";
        this.chartControl1.PrimaryYAxis.LabelAligment = System.Drawing.StringAlignment.Center;
        this.chartControl1.PrimaryYAxis.SmartDateZoomMonthLevelLabelFormat = "m";
        this.chartControl1.Size = new System.Drawing.Size(512, 456);
        this.chartControl1.TabIndex = 1;
        this.chartControl1.Text = "Essential Chart";
        this.chartControl1.ToolBar.Location = new System.Drawing.Point(0, 0);
        this.chartControl1.ZoomOutIncrement = 1.5;
        this.chartControl1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.chartControl1_MouseUp);
        this.chartControl1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chartControl1_MouseMove);
        this.chartControl1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.chartControl1_MouseDown);
      
        // 
        // panel1
        // 
        this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                    | System.Windows.Forms.AnchorStyles.Right)));
        this.panel1.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(167)))), ((int)(((byte)(184)))), ((int)(((byte)(210)))));
        this.panel1.Controls.Add(this.label6);
        this.panel1.Controls.Add(this.label5);
        this.panel1.Controls.Add(this.label4);
        this.panel1.Controls.Add(this.label3);
        this.panel1.Controls.Add(this.label2);
        this.panel1.Controls.Add(this.label1);
        this.panel1.Controls.Add(this.groupBox1);
        this.panel1.Location = new System.Drawing.Point(512, 0);
        this.panel1.Name = "panel1";
        this.panel1.Size = new System.Drawing.Size(160, 456);
        this.panel1.TabIndex = 2;
      
        // 
        // groupBox1
        // 
        this.groupBox1.Controls.Add(this.colorPickerButton1);
        this.groupBox1.Controls.Add(this.radioButton2);
        this.groupBox1.Controls.Add(this.radioButton1);
        this.groupBox1.FlatStyle = System.Windows.Forms.FlatStyle.System;
        this.groupBox1.Location = new System.Drawing.Point(16, 40);
        this.groupBox1.Name = "groupBox1";
        this.groupBox1.Size = new System.Drawing.Size(136, 160);
        this.groupBox1.TabIndex = 1;
        this.groupBox1.TabStop = false;
        this.groupBox1.Text = "Interactive Cursor Color";
        // 
        // colorPickerButton1
        // 
        this.colorPickerButton1.ColorUISize = new System.Drawing.Size(208, 230);
        this.colorPickerButton1.Location = new System.Drawing.Point(32, 112);
        this.colorPickerButton1.Name = "colorPickerButton1";
        this.colorPickerButton1.SelectedColorGroup = Syncfusion.Windows.Forms.ColorUISelectedGroup.None;
        this.colorPickerButton1.Size = new System.Drawing.Size(75, 23);
        this.colorPickerButton1.TabIndex = 2;
        this.colorPickerButton1.Text = "Select Color";
        this.colorPickerButton1.ColorSelected += new System.EventHandler(this.Color_selected);
        // 
        // radioButton2
        // 
        this.radioButton2.FlatStyle = System.Windows.Forms.FlatStyle.System;
        this.radioButton2.Location = new System.Drawing.Point(24, 64);
        this.radioButton2.Name = "radioButton2";
        this.radioButton2.Size = new System.Drawing.Size(80, 16);
        this.radioButton2.TabIndex = 1;
        this.radioButton2.Text = "Server 2";
        // 
        // radioButton1
        // 
        this.radioButton1.Checked = true;
        this.radioButton1.FlatStyle = System.Windows.Forms.FlatStyle.System;
        this.radioButton1.Location = new System.Drawing.Point(24, 32);
        this.radioButton1.Name = "radioButton1";
        this.radioButton1.Size = new System.Drawing.Size(80, 16);
        this.radioButton1.TabIndex = 0;
        this.radioButton1.TabStop = true;
        this.radioButton1.Text = "Server 1";
        // 
        // label1
        // 
        this.label1.AutoSize = true;
        this.label1.Location = new System.Drawing.Point(37, 225);
        this.label1.Name = "label1";
        this.label1.Size = new System.Drawing.Size(0, 13);
        this.label1.TabIndex = 2;
        // 
        // label2
        // 
        this.label2.AutoSize = true;
        this.label2.Location = new System.Drawing.Point(37, 258);
        this.label2.Name = "label2";
        this.label2.Size = new System.Drawing.Size(0, 13);
        this.label2.TabIndex = 3;
        // 
        // label3
        // 
        this.label3.AutoSize = true;
        this.label3.Location = new System.Drawing.Point(37, 318);
        this.label3.Name = "label3";
        this.label3.Size = new System.Drawing.Size(0, 13);
        this.label3.TabIndex = 4;
        // 
        // label4
        // 
        this.label4.AutoSize = true;
        this.label4.Location = new System.Drawing.Point(37, 348);
        this.label4.Name = "label4";
        this.label4.Size = new System.Drawing.Size(0, 13);
        this.label4.TabIndex = 5;
        // 
        // label5
        // 
        this.label5.AutoSize = true;
        this.label5.Location = new System.Drawing.Point(18, 209);
        this.label5.Name = "label5";
        this.label5.Size = new System.Drawing.Size(99, 13);
        this.label5.TabIndex = 6;
        this.label5.Text = "Interactive Cursor 1";
        // 
        // label6
        // 
        this.label6.AutoSize = true;
        this.label6.Location = new System.Drawing.Point(18, 295);
        this.label6.Name = "label6";
        this.label6.Size = new System.Drawing.Size(96, 13);
        this.label6.TabIndex = 7;
        this.label6.Text = "Interactive Cursor2";
        // 
        // FormMain
        // 
        this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
        this.ClientSize = new System.Drawing.Size(672, 454);
        this.Controls.Add(this.panel1);
        this.Controls.Add(this.chartControl1);
        this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
        this.Name = "FormMain";
        this.Text = "Essential Chart - Line Chart Sample with Interactive Cursor";
        this.Load += new System.EventHandler(this.FormMain_Load);
        this.panel1.ResumeLayout(false);
        this.panel1.PerformLayout();
        this.groupBox1.ResumeLayout(false);
        this.ResumeLayout(false);

	}
    #endregion

    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    [STAThread]
    static void Main() 
    {
      Application.Run(new FormMain());
    }

		
    private void FormMain_Load(object sender, EventArgs e)
    {
      InitializeChartData();
      InitializeChartAppearance();
	  InitializeControlSettings();

    }

    /// <summary>
    /// Initializes the ChartControl's data and sets the Chart type
    /// </summary>
    protected void InitializeChartData()
    {
		this.chartControl1.Indexed=true;
		ChartSeries series1 = this.chartControl1.Model.NewSeries(" Server1",ChartSeriesType.Line );
		series1.Text = series1.Name;

		int[] r1  = new int[]{256,491,382,437,321,234,425,257,382,296,437,451,490,366,422,361,185,384,461,258};
		
		for(int i=0;i<20;i++)
			series1.Points.Add(i,r1[i]);

		ChartSeries series2 = this.chartControl1.Model.NewSeries(" Server 2",ChartSeriesType.Line );
		series2.Text = series2.Name;

		int[] r2  = new int[]{437,451,490,366,422,163,289,384,461,256,491,382,437,321,234,425,257,382,296,491};
		
		for(int i=0;i<20;i++)
			series2.Points.Add(i,r2[i]);

		series1.PrepareStyle+=new ChartPrepareStyleInfoHandler(ChartControlSeries_PrepareStyle);
		series2.PrepareStyle+=new ChartPrepareStyleInfoHandler(ChartControlSeries_PrepareStyle);

		this.chartControl1.Series.Add(series1);
		this.chartControl1.Series.Add(series2);
		this.chartControl1.Text="Network Load";
		this.chartControl1.PrimaryXAxis.LabelRotate=true;
		this.chartControl1.PrimaryXAxis.LabelRotateAngle=30;
    }

    /// <summary>
    /// Sets properties to customize the ChartControl's appearance
    /// </summary>
    protected void InitializeChartAppearance()
    {
      //this.chartControl1.Series[0].Style.Border.Color = Color.FromArgb(200, Color.Yellow);
      this.chartControl1.Series[0].Style.Border.Width = 2;
      this.chartControl1.Series[1].Style.Border.Width = 2;

      this.chartControl1.PrimaryXAxis.Range = new MinMaxInfo(0, 20, 2);

  ////////////////////////////////////////////////////////////////////////////////// 
        // Add interactive cursor

		chart1 = new ChartInteractiveCursor(this.chartControl1.Series[0]);
        chart2 = new ChartInteractiveCursor(this.chartControl1.Series[1]);   
		InteractiveCursors.Add(chart1 );
		InteractiveCursors.Add(chart2 );

  ////////////////////////////////////////////////////////////////////////////////////      
        
    }	
	

    /// <summary>
    /// Handler for the PrepareStyle event of ChartSeries. 
    /// </summary>
    /// <param name="sender">The ChartSeries object that raises this event.</param>
    /// <param name="args">The event data. Can be modified to change series appearance.</param>
    protected void ChartControlSeries_PrepareStyle(object sender, ChartPrepareStyleInfoEventArgs args)
    {
      // Style formatting using a callback. You can apply the same settings directly on the series style on the
      // point styles.
      ChartSeries series = sender as ChartSeries;
      if(series != null)
      {
        args.Style.DisplayText = true;
        args.Style.TextFormat = "{0}";
        args.Style.TextOffset = 15;
				
        if(series == this.chartControl1.Series[0])
          args.Style.TextOrientation = ChartTextOrientation.Up;
        else
          args.Style.TextOrientation = ChartTextOrientation.Right;

        args.Style.Symbol.Shape = ChartSymbolShape.Square;
        args.Style.Symbol.Size = new Size(5,5);
        args.Style.Symbol.Color = Color.DarkCyan;
        args.Style.DisplayShadow = true;
      }
    }

  	private void Color_selected(object sender, System.EventArgs e)
	  {
		if(this.radioButton1.Checked)
			chart1.Color = this.colorPickerButton1.SelectedColor;
		else
			chart2.Color = this.colorPickerButton1.SelectedColor;
		this.chartControl1.Redraw(true);
	  }




      //\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

      private void chartControl1_MouseDown(object sender, MouseEventArgs e)
      {
          if (e.Button == MouseButtons.Left)
          {
              clickPoint = new Point(e.X, e.Y);

              for (int i = 0; i < InteractiveCursors.Count; i++)
              {
                  ChartInteractiveCursor cur = InteractiveCursors[i] as ChartInteractiveCursor;

                  if (cur.IsXLocation(this.chartControl1.ChartArea.CorrectionTo(clickPoint)))
                  {
                      this.Cursor =Cursors.SizeWE;
                      interactiveCursorMouseDown = true;
                      interactiveCursorDown = cur;
                      break;
                  }                 
                  else
                  {
                      this.Cursor = Cursors.Default;
                      interactiveCursorMouseDown = false;
                  }
              }
          }
      }

      private void chartControl1_MouseMove(object sender, MouseEventArgs e)
      {
          Point movePoint = new Point(e.X, e.Y);
          bool interactiveCursorMoved = false;
          
          if ((!interactiveCursorMouseDown) && (clickPoint != Point.Empty))
          {
              for (int i = 0; i < InteractiveCursors.Count; i++)
              {
                  ChartInteractiveCursor cur = InteractiveCursors[i] as ChartInteractiveCursor;
                  if (cur.IsXLocation(this.chartControl1.ChartArea.CorrectionTo(movePoint)))
                  {
                      this.Cursor =Cursors.SizeWE;
                      break;
                  }                  
                  else
                  {
                      this.Cursor = Cursors.Default; 
                  }
              }
          }
          else
          {
              if (this.Cursor == Cursors.SizeWE)
              {
                  interactiveCursorDown.HorizontalMove(this.chartControl1.ChartArea.GetValueByPoint(movePoint).X);
                  interactiveCursorMoved = true;
                 
              }
              
          }
      }

      private void chartControl1_MouseUp(object sender, MouseEventArgs e)
      {
          
             
                  interactiveCursorDown = null;
                  interactiveCursorMouseDown = false;
                  clickPoint = Point.Empty;
                  //mouseDownPosition = Point.Empty;
                  ResetCursor();
                 
              
          }


      void chartControl1_ChartAreaPaint(object sender, PaintEventArgs e)
      {
          Graphics g = e.Graphics;
          Rectangle bounds = this.chartControl1.ChartArea.RenderBounds;
         

          for (int i = 0; i < interactiveCursors.Count; i++)
          {
              PointF curpos = interactiveCursors[i].Location;

              if (bounds.Left < curpos.X) 
              //g.DrawLine(new Pen(interactiveCursors[i].Color, 1), bounds.Left, curpos.Y, bounds.Right, curpos.Y);
              g.DrawLine(new Pen(interactiveCursors[i].Color, 1), curpos.X, bounds.Top, curpos.X, bounds.Bottom);
          }

          label1.Text = "X = " + interactiveCursors[0].Point.X.ToString();
          label2.Text = "Y = " + interactiveCursors[0].Point.YValues[0].ToString();

          label3.Text = "X = " + interactiveCursors[1].Point.X.ToString();
          label4.Text = "Y = " + interactiveCursors[1].Point.YValues[0].ToString();

      }

    ///////////////////////////////////////////////////////////////////////////////////
      }
  }

